[CF15C]Industrial Nim】的更多相关文章

题目大意:有$n$个采石场,每行一个$m_i$一个$x_i$,表示第$i$个采石场有$m_i$辆车,这个采石场中车中的石子为从$x_i$开始的自然数.Nim游戏若先手赢输出"tolik",后手赢输出"bolik". 题解:Nim游戏,可以发现连续的四个自然数且第一个数可被4整除,那么它们的异或值为0 卡点:1.未考虑$m_i < 4$的情况 2.未考虑$x_i < 4$的情况 C++ Code: #include <cstdio> #defi…
C. Industrial Nim time limit per test 2 seconds memory limit per test 64 megabytes input standard input output standard output There are n stone quarries in Petrograd. Each quarry owns mi dumpers (1 ≤ i ≤ n). It is known that the first dumper of the…
题目链接:http://codeforces.com/problemset/problem/15/C $NIM$游戏是次要的,直接异或石头堆就可以了,问题在于给出的石头堆的数量极多. 考虑利用异或的性质. 一共给出了$n$段石头堆,每段中石头堆的数量是连续的. 在$x$是偶数时${x~~xor~~(x+1)=1}$,利用这个性质我们就可以${O(1)}$的算出每一段石头的异或和. #include<iostream> #include<cstdio> #include<alg…
http://codeforces.com/contest/15/problem/C 题意: 现有n个采石场,第i个采石场有mi堆石子 各堆分别有xi,xi+1……,xi+m-1颗石子 两名选手使用最优策略进行Nim游戏,双方轮流操作 每次操作为从任意一堆石子取出任意数量的石子,不能操作者败 现对于一初始局面,先手必胜输出“tolik”,否则输出“bolik”(不含引号) 解法: 显然核心算法仍然是Nim 然后用脑子想想 f(x)表示1-x的异或和怎么求就好了 其实怎么求都可以,想清楚就好了 #…
主题链接:点击打开链接 意甲冠军: 特定n 下列n行,每一行2的数量u v 表达v礧:u,u+1,u+2···u+v-1 问先手必胜还是后手必胜 思路: 首先依据Nim的博弈结论 把全部数都异或一下,看结果是0还是非0 而这里由于数字太多所以想优化 那么事实上对于一个序列 u, u+1, u+2 ···· 显然 {4,5} {,6,7}, {8,9} 这样2个一组的异或结果就是1 那么仅仅须要把序列分组,分成{偶数,奇数} 然后Y一下. . #include<stdio.h> #include…
You are playing the following Nim Game with your friend: There is a heap of stones on the table, each time one of you take turns to remove 1 to 3 stones. The one who removes the last stone will be the winner. You will take the first turn to remove th…
http://codeforces.com/problemset/problem/662/A 题目大意: 给定n(n <= 500000)张卡片,每张卡片的两个面都写有数字,每个面都有0.5的概率是在正面,各个卡牌独立.求把所有卡牌来玩Nim游戏,先手必胜的概率. (⊙o⊙)-由于本人只会在word文档里写公式,所以本博客是图片格式的. Code #include <cstdio> #include <cstring> #include <algorithm> u…
A Simple Nim Problem Description   Two players take turns picking candies from n heaps,the player who picks the last one will win the game.On each turn they can pick any number of candies which come from the same heap(picking no candy is not allowed)…
Problem: You are playing the following Nim Game with your friend: There to stones. The one who removes the last stone will be the winner. You will take the first turn to remove the stones. Both of you are very clever and have optimal strategies for t…
题意 \(K(1 \le K \le 10^9)\)堆石子,每堆石子个数不超过\(L(2 \le 50000)\),问Nim游戏中先手必败局面的数量,答案对\(10^9+7\)取模. 分析 容易得到\(f(i, k) = \sum_{j=0}^{n-1} f(i-1, j) f(i-1, k^j), f(1, i(2 \le i \le L))=1\),其中\(n=min(2^i, 2^i > L)\).发现其实这就是操作为\(xor\)的卷积.于是用鬼畜的fwt做就行了. 题解 然后fwt+快…